-- Ŀ
--  Play-AVI.E V1.00 (C) 1999 Legend Interactive            AVI Playback Lib 
-- 
-- This experimental library contains code to play Windows AVI files in
-- the following formats only :-
--   8-Bit RGB (Uncompressed)
--   8-Bit RLE (Run-Length Encoded)
-- Video only

-- Reasons that this code might fail to play a particular AVI movie
-- might be :-
--  1. A bug in my code - if so tell me.
--  2. Unknown compression format - If I don't know how it works I can't
--     write code for it..
--  3. Unsupported compression format - There are limits to what Euphoria
--     can do.

-- Feel free to hack this code into your own projects. If you have any
-- trouble you can contact me on Peter.Blue@legend-i.demon.co.uk

-- Watch our web site for more updates - www.legend-i.demon.co.uk

include graphics.e -- RDS
include get.e -- RDS
include core-avi.e

integer xsize, ysize
sequence quad
object junk

global function OpenPicAVI(sequence ifn)
  integer ifh -- Input File Handle
  integer tmp1,tmp2
  sequence pal
  
  ifh = open(ifn,"rb")
  if ifh < 1 then
    return -1
  end if
  
  AviBitsPerPixel = -1
  xsize = 0
  ysize = 0
  junk = get_bytes(ifh,4) -- {"RIFF"}
  AviFileSize = ReadLongI86(ifh)
  junk = get_bytes(ifh,4) -- {"AVI "}
  junk = get_bytes(ifh,4) -- {"LIST"}
  
  while 1 do -- Step through header info
    quad = get_bytes(ifh,4)
    
    if compare(quad,"movi") = 0 then
      exit -- Where's the popcorn !
    elsif compare(quad,"avih") = 0 then
      junk = get_bytes(ifh,4)
      AviFrameDelay = ReadLongI86(ifh)
      junk = ReadLongI86(ifh) -- Data rate
      junk = ReadLongI86(ifh) -- Reserved
      junk = ReadLongI86(ifh) -- Flags
      AviFrames = ReadLongI86(ifh)
      junk = ReadLongI86(ifh) -- Initial frames
      junk = ReadLongI86(ifh) -- Data streams
      junk = ReadLongI86(ifh) -- Buff size
      xsize = ReadLongI86(ifh) -- Width
      ysize = ReadLongI86(ifh) -- Height
      junk = ReadLongI86(ifh) -- Time scale
      junk = ReadLongI86(ifh) -- Data rate
      xsize = 0
      ysize = 0
    elsif compare(quad,"strl") = 0 then
    elsif compare(quad,"strh") = 0 then
      junk = get_bytes(ifh,4)
      AviType = get_bytes(ifh,4)
      AviHandler = get_bytes(ifh,4)
      junk = get_bytes(ifh,40)
    elsif compare(quad,"strf") = 0 then
      junk = get_bytes(ifh,4)
      junk = get_bytes(ifh,4)
      tmp1 = ReadLongI86(ifh)
      tmp2 = ReadLongI86(ifh)
      if xsize < 1 then
	xsize = tmp1
      end if
      if ysize < 1 then
	ysize = tmp2
      end if
      junk = ReadIntI86(ifh) -- Planes
      AviBitsPerPixel = ReadIntI86(ifh)
      AviCompression = ReadLongI86(ifh)
      junk = get_bytes(ifh,4) -- Image size
      junk = get_bytes(ifh,16)
      pal = repeat({0,0,0},256)
      for p = 1 to 256 do
	pal[p][3] = getc(ifh)
	pal[p][2] = getc(ifh)
	pal[p][1] = getc(ifh)
	junk = getc(ifh)
      end for
    elsif compare(quad,"LIST") = 0 then
      junk = get_bytes(ifh,4)
    elsif compare(quad,"JUNK") = 0 then
      tmp1 = ReadLongI86(ifh)
      junk = get_bytes(ifh,tmp1)
    end if
  end while

  AviFrame1 = where(ifh)
  AviFrame = 1
  
  AviWidth = xsize
  AviHeight = ysize
  if AviFrameDelay < 1 then
    AviFrameDelay = 66666
  end if
  
  AviFramesPerSecond = floor(AviTimeScale / AviFrameDelay)
  if AviFramesPerSecond < 0 then
    AviFramesPerSecond = 15
  end if
  
  if compare(AviHandler,{0,0,0,0}) = 0 then
    AviHandler = "RGB "
  end if
  
  all_palette(pal / 4)
  
  return ifh
end function

global procedure NextFrameAVI(integer ifh)
  integer blen,byt,xi,yi,esc,col,tmp
  sequence quad,pix
  
  quad = get_bytes(ifh,4)
  blen = ReadLongI86(ifh)
  if compare(quad,"00db") = 0 then -- Un-compressed frame
    for y = AviHeight - 1 to 0 by -1 do
      pixel(get_bytes(ifh,AviWidth),{0,y})
    end for
  elsif compare(quad,"00dc") = 0 then -- RLE Compressed frame
    xi = 0
    yi = AviHeight - 1
    esc = 0
    while 1 do
      byt = getc(ifh)
      if byt > 0 then -- Run of same colour
	col = getc(ifh) -- Get colour
	--pix = repeat(col,byt) -- Repeat
	--pixel(pix,{xi,yi}) -- Plot
	pixel(repeat(col,byt),{xi,yi}) -- Plot
	xi = xi + byt
      else -- Byt = 0
	esc = getc(ifh) -- Get ESC code
	if esc = 0 then -- End of line
	  xi = 0
	  yi = yi - 1
	elsif esc = 1 then -- End of image
	  exit
	elsif esc = 2 then -- XY Delta
	  xi = xi + getc(ifh)
	  yi = yi - getc(ifh)
	else -- esc 3 ~ 255 Run of different colours (Literal run)
	  pix = get_bytes(ifh,esc)
	  if and_bits(esc,1) > 0 then -- Ensure we end on INT boundry
	    tmp = getc(ifh)
	  end if
	  pixel(pix,{xi,yi}) -- Plot
	  xi = xi + length(pix)
	end if
      end if
    end while
  end if
  
  AviFrame = AviFrame + 1
  if AviFrame > AviFrames then -- Let's go round again !
    if seek(ifh,AviFrame1) = 0 then -- OK
      AviFrame = 1
    else -- Oops !
      puts(1,"NextFrameAVI: Seek failure !\n")
      close(ifh)
      abort(1)
    end if
  end if
end procedure

global procedure ClosePicAVI(integer ifh)
  if ifh > 0 then
    close(ifh)
  end if
  ifh = -1
end procedure

