-- Ŀ
--  Play-FLI.E V1.06 (C) 1999 Legend Interactive  FLI decompression library 
-- 
-- Authors  Peter Blue [PJB]       - Main code & hacking .FLI format.
--                                 - Peter.Blue@legend-i.demon.co.uk
--                                 - www.legend-i.demon.co.uk/
--          Robert Craig [RHC]     - Doubling speed by enhancing Euphoria
--                                   (V1.4B) and re-writing this lib to use it.
--          Jacques Deschenes [JD] - Minor speed-up.

-- Feel free to use this code in your own projects. If you are having trouble
-- hacking this code to fit into your game/demo give me a call.

-- NOTE: This is an experimental library, it is not meant to be a
--       finished product - yet. I still need to make it a lot faster, and
--       to add support for FLC files.

--       This might not play all .FLI animations because :-
--         1. There might be a bug in this code (if so, tell me)
--         2. The program used to create the .FLI file might be using some
--            weird compression scheme unknown to me at this time.


include graphics.e
include get.e
include file.e
include Numeric2.E

global sequence DefaultAnim DefaultAnim = repeat(0,10)
global constant aHandle = 1
global constant aXsize = 2
global constant aYsize = 3
global constant aFrames = 4
global constant aRFpS = 5
global constant aFrame = 6
global constant aFlag1 = 7
global constant aFlag2 = 8
global constant aPal = 9
global constant aXL = 10
global constant aYT = 11


-- This handles Delta-RLE decompression
procedure ByteDelta (atom ifc,integer xsize,integer y,integer xl)
    integer x,h,packets,byt,pix,skp
    sequence hz
    hz = repeat(0, xsize) -- Horizontal buffer

    x = 0 -- Start at left
    h = 0
    packets = getc(ifc) -- get packets in current line
    for p = 1 to packets do
      skp = getc(ifc) -- get horz pixels to skip
      if skp then
	-- output what we've got so far:
	pixel(hz[(x + 1)..h],{x + xl,y})
	x = h + skp
	h = x
      end if
      byt = getc(ifc)  -- get compression/byte count
      if byt <= 127 then -- Copy
	for c = h + 1 to h + byt do -- [JD]
	  hz[c] = getc(ifc)
	end for
	h = h + byt
      else -- Byte run [RHC]
	byt = byt - 256 -- byt is negative
	pix = getc(ifc)
	hz[h+1..h-byt] = pix
	h = h - byt
      end if
    end for -- packets
    --output last piece:
    pixel(hz[(x + 1)..h],{x + xl,y})
end procedure

-- This handles RLE decompression
procedure ByteRunLength (atom ifc,integer xsize,integer y,integer xl)
  integer x,packets,byt,cnt,pix,h
  sequence hz
  hz = repeat(0,xsize) -- Setup horizontal buffer
  x = 1 -- Start at left
  while x <= xsize do
    packets = getc(ifc)  -- get packets in current line
    for p = 1 to packets do
      byt = ReadSgnByte(ifc)
      if byt < 0 then -- Copy
	cnt = -byt
	for c = 1 to cnt do
	  hz[x] = getc(ifc)
	  x = x + 1
	end for
      else -- Byte run [RHC]
	h = x + byt
	pix = getc(ifc)
	hz[x..h - 1] = repeat(pix,byt)
	x = h
      end if
    end for
  end while
  pixel(hz,{xl,y})
end procedure

global function OpenPicFLI(sequence ifn)
  atom ifc  -- Input File Channel
  -- integer xsize,ysize,csize,xcent,ycent,delay,r,g,b,xl,yt
  integer xsize,ysize,csize,xcent,ycent,delay,xl,yt
  integer fsize,frames,frame
  integer junk,vdux,vduy,vduc
  sequence Anim,vc
  
  Anim = repeat(0,12)
  ifc = open(ifn,"rb")
  if ifc < 0 then
    printf(1,"Can't find file %s ! \n",{ifn})
    return Anim
  end if
  -- Read useful header data
  junk   = ReadLongI86(ifc)  -- File size
  junk   = ReadIntI86(ifc)   -- Sig AF11h
  frames = ReadIntI86(ifc)   -- Frames
  xsize  = ReadIntI86(ifc)   -- Width in pixels
  ysize  = ReadIntI86(ifc)   -- Hight in pixels
  csize  = ReadIntI86(ifc)   -- Normaly 8 (256 colours)
  junk   = ReadIntI86(ifc)
  delay  = ReadLongI86(ifc)  -- Delay in 1/70 seconds (FPS = 70/delay)
  
  if delay = 0 then -- [RHC] 
    delay = 5 -- Safe default value
  end if
  
  junk   = ReadIntI86(ifc)
  for j = 1 to 106 do
    junk = getc(ifc)
  end for


  vc = video_config()
  vdux = vc[5]
  vduy = vc[6]
  vduc = vc[7]

  xcent = floor(vdux / 2)
  ycent = floor(vduy / 2)
  xl = floor( xcent - (xsize / 2) )
  yt = floor( ycent - (ysize / 2) )
  
  -- This info is returned to calling program
  Anim[aHandle] = ifc -- File will be left open during playback
  Anim[aXsize]  = xsize
  Anim[aYsize]  = ysize
  Anim[aFrames] = frames
  Anim[aRFpS]   = (70 / delay)
  Anim[aFrame]  = 1 -- First frame
  Anim[aFlag1]  = -1 -- Frame #2 pointer - set void for now
  Anim[aFlag2]  = 1 -- Enable start-frame, disable ring-frame
  Anim[aPal]    = {} -- Palette
  Anim[aXL]     = xl
  Anim[aYT]     = yt
  return Anim
end function
  
global function NextFrameFLI(sequence Anim)
  atom ifc  -- Input File Channel
  integer xsize,ysize,csize,delay,key,r,g,b
  integer fsize,frames,frame
  integer junk,pals,palc
  integer y1,y2,xl,yt
  integer chunks,chsize,chtype,chaddr,packets,lastchnk,lastaddr
  sequence pal,hz

  ifc    = Anim[aHandle]
  xsize  = Anim[aXsize]
  ysize  = Anim[aYsize]
  frames = Anim[aFrames]
  frame  = Anim[aFrame]
  pal    = Anim[aPal]
  xl     = Anim[aXL]
  yt     = Anim[aYT]
  
  if frame = 2 then -- We won't know where frame 2 is 'til we get there !
    if (Anim[aFlag1] < 0) then -- Get frame #2 location once only
      Anim[aFlag1] = where(ifc)
    end if
  end if
  
  -- Read frame data
  fsize  = ReadLongI86(ifc) -- Frame size
  junk   = ReadIntI86(ifc)
  chunks = ReadIntI86(ifc)  -- chunks in frame
  junk   = ReadIntI86(ifc)
  junk   = ReadIntI86(ifc)
  junk   = ReadIntI86(ifc)
  junk   = ReadIntI86(ifc)
  for ch = 1 to chunks do -- Step through chunks
    chaddr  = where(ifc) -- [?] Diags only
    chsize  = ReadLongI86(ifc) -- chunk size
    chtype  = ReadIntI86(ifc)  -- chunk type
    if chtype = 11 then -- COLOR_64 (Palette data)
      packets = ReadIntI86(ifc)
      for p = 1 to packets do
	pals = getc(ifc)
	palc = getc(ifc)
	if palc = 0 then -- 0 = 256
	  palc = 256
	end if
	for i = pals to pals + palc - 1 do
	  r = getc(ifc)
	  g = getc(ifc)
	  b = getc(ifc)
	  pal = append(pal,{r,g,b})
	end for
      end for
      all_palette(pal)
      Anim[aPal] = pal
      
    elsif chtype = 12 then -- FLI_DELTA (Delta decompression)
      y1 = ReadIntI86(ifc) -- Start line
      y2 = ReadIntI86(ifc) -- Line count
      for y = y1 to y1 + y2 - 1 do --[!]
	ByteDelta(ifc,xsize,y + yt,xl)
      end for
      
    elsif chtype = 13 then -- FLI_BLACK (Black screen)
      for y = 0 to ysize - 1 do
	pixel(repeat(0,xsize),{xl,y + yt})
      end for
      
    elsif chtype = 15 then -- FLI_BYTE_RUN (RLE decompression)
      for y = 0 to ysize - 1 do
	ByteRunLength(ifc,xsize,y + yt,xl)
      end for
	
    elsif chtype = 16 then -- FLI_COPY (Block copy)
      hz = repeat(0,xsize)
      for y = 0 to ysize - 1 do
	for h = 1 to xsize do
	  hz[h] = getc(ifc)
	end for
	pixel(hz,{xl,y + yt})
      end for
      
    else -- [?] Normaly you would step over unknown chunks
      printf(1,"Unknown chunk %d at %x (HEX)!\n",{chtype,chaddr})
      printf(1,"Last chunk    %d at %x (HEX)\n",{lastchnk,lastaddr})
      abort(2)
    end if
      
    junk = seek(ifc,chsize + chaddr) -- [PJB] This should be OK 
    lastchnk = chtype -- [?] Handy for diagnostics
    lastaddr = chaddr
  end for
    
  frame = frame + 1
  if frame > frames + Anim[aFlag2] then -- Go back to start
    frame = 1
    Anim[aFlag2] = 0 -- disable start-frame, enable ring-frame
    junk = seek(ifc,Anim[aFlag1])
  end if
  
  Anim[aFrame] = frame
  return Anim
end function
  
global function ClosePicFLI(sequence Anim)
  if Anim[aHandle] > 0 then
    close(Anim[aHandle])
  end if
  Anim[aHandle] = 0
  
  return Anim
end function

