-- V1.03 This program is used to test Save-AVI.E

include save-avi.e -- LIL Lib

integer Handle,Frames,junk,xc,yc,lume
atom phase1,phase2,wave1,wave2,pi
sequence pal

pi = arctan(1) * 4 -- Easiest way to find pi
xc = floor(320 / 2)
yc = floor(200 / 2)

junk = graphics_mode(19) -- Screen set to 320x200 pixels, 256 colours
pal = get_all_palette() -- Get current palette
for p = 0 to 63 do -- Make a few changes
  pal[p + 64][1] = p
  pal[p + 64][2] = p
  pal[p + 64][3] = 32 + floor(p / 2)
end for
all_palette(pal) -- Save palette

AviFramesPerSecond = 15
AviBitsPerPixel = 24 -- Try 8 ,16 or 24
Frames = 32
Handle = SaveHeaderAVI("TestFile.AVI",320,200,Frames)

if Handle < 1 then -- Oops !
  puts(1,"File error \n")
  abort(1)
end if

phase1 = 0
phase2 = 0
for frame = 1 to Frames do
  wave1 = phase1
  wave2 = phase2
  
  for rad = 0 to 320 do
    lume = 63 + (floor(32 + (sin(wave1) * 20) + (sin(wave2) * 10)))
    wave1 = wave1 + .1
    wave2 = wave2 + .4
    
    ellipse(lume,0,{xc - rad,yc - rad},{xc + rad,yc + rad})
    xc = xc + 1
    ellipse(lume,0,{xc - rad,yc - rad},{xc + rad,yc + rad})
    xc = xc - 1
    yc = yc + 1
    ellipse(lume,0,{xc - rad,yc - rad},{xc + rad,yc + rad})
    yc = yc - 1
  end for
  phase1 = phase1 - ((pi * 2) / Frames)
  phase2 = phase2 - ((pi * 4) / Frames)
  
  text_color(14)
  position(1,1)
  printf(1," Frame %d of %d ",{frame,Frames})
  
  SaveScreenAVI(Handle)
end for

CloseHeaderAVI(Handle)

junk = graphics_mode(-1)
puts(1,"Animation complete, Use the MediaPlayer to view\n")

